precision mediump float;
varying vec2 v_Tex;
uniform sampler2D u_Tex;
uniform float intensity;

// Adjust Brightness

vec3 adjustBrightness(vec3 color, float brightness) {
    return clamp(color + vec3(brightness), 0.0, 1.0);
}

vec4 adjustBrightness(vec4 color, float brightness) {
    return vec4(adjustBrightness(color.rgb, brightness), color.a);
}

void main(void) {

    float intensity = intensity - 0.5;
    vec4 color = texture2D(u_Tex, v_Tex);
    color = adjustBrightness(color, intensity);
    gl_FragColor = color;

}
