precision mediump float;
varying vec2 v_Tex;
uniform sampler2D u_Tex;
uniform float intensity;

// Adjust Contrast

vec3 adjustContrast(vec3 color, float contrast) {
    float t = 0.5 - contrast * 0.5;
    return clamp(color * vec3(contrast) + vec3(t), 0.0, 1.0);
}

vec4 adjustContrast(vec4 color, float contrast) {
    return vec4(adjustContrast(color.rgb, contrast), color.a);
}

void main(void) {

    float intensity = mix(0.5, 1.5, intensity);
    vec4 color = texture2D(u_Tex, v_Tex);
    color = adjustContrast(color, intensity);
    gl_FragColor = color;

}
