precision mediump float;
varying vec2 v_Tex;
uniform sampler2D u_Tex;
uniform float intensity;

// Adjust Exposure

vec4 adjustExposure(vec4 color, float intensity) {
    vec3 luminanceWeighting = vec3(0.2125, 0.7154, 0.0721);
    float luminance = dot(luminanceWeighting, color.rgb);
    return vec4(clamp(color.rgb + luminance * intensity, 0.0, 1.0), color.a);
}

void main(void) {

    float intensity = intensity - 0.5;
    vec4 color = texture2D(u_Tex, v_Tex);
    color.rgb = pow(color.rgb, vec3(1.0/2.2));
    color = adjustExposure(color, intensity);
    color.rgb = pow(color.rgb, vec3(2.2));
    gl_FragColor = color;

}
