precision mediump float;
varying vec2 v_Tex;
uniform sampler2D u_Tex;
uniform float intensity;

#define PI 3.14159265359

// Hue Shift

vec3 hueShift(vec3 color, float hue) {
    const vec3 k = vec3(0.57735, 0.57735, 0.57735);
    float cosAngle = cos(hue);
    return vec3(color * cosAngle + cross(k, color) * sin(hue) + k * dot(k, color) * (1.0 - cosAngle));
}

void main(void) {

    float intensity = (intensity - 0.5) * 2.0 * PI;
    vec4 color = texture2D(u_Tex, v_Tex);
    color.rgb = hueShift(color.rgb, intensity);
    gl_FragColor = color;

}
