precision mediump float;
varying vec2 v_Tex;
uniform sampler2D u_Tex;
uniform float intensity;

// Adjust Saturation

vec4 adjustSaturation(vec4 col, float intensity) {
    // Algorithm from Chapter 16 of OpenGL Shading Language
    const vec3 W = vec3(0.2125, 0.7154, 0.0721);
    vec3 gray = vec3(dot(col.rgb, W));
    return vec4(mix(gray, col.rgb, intensity), col.a);
}


void main(void) {

    float intensity = 2.0 * intensity;
    vec4 color = texture2D(u_Tex, v_Tex);
    color = adjustSaturation(color, intensity);
    gl_FragColor = color;

}
