precision highp float;
varying vec2 v_Tex;
uniform sampler2D u_Tex;
uniform float intensity;

const vec3 warmFilter = vec3(0.93, 0.54, 0.0);
const mat3 RGBtoYIQ = mat3(0.299, 0.587, 0.114, 0.596, -0.274, -0.322, 0.212, -0.523, 0.311);
const mat3 YIQtoRGB = mat3(1.0, 0.956, 0.621, 1.0, -0.272, -0.647, 1.0, -1.105, 1.702);

void main(void) {

    float intensity = 2.0 * intensity - 1.0;
    vec4 source = texture2D(u_Tex, v_Tex);
    // adjusting tint
    vec3 yiq = RGBtoYIQ * source.rgb;
    yiq.b = clamp(yiq.b + intensity*0.5226*0.1, -0.5226, 0.5226);
    vec3 rgb = YIQtoRGB * yiq;

    gl_FragColor = vec4(rgb, source.a);

}
