precision mediump float;
varying vec2 v_Tex;
uniform float blendRatio;
uniform sampler2D u_Tex;
uniform vec4 color1;
uniform vec4 color2;
uniform float direction; // in radians, counter-clockwise

#define PI 3.14159265359

mat2 rotate(float angle) {
    return mat2(cos(angle),-sin(angle),
                sin(angle),cos(angle));
}

void main(void) {

    vec4 imageCol = texture2D(u_Tex, v_Tex);
    vec2 rotatedUV = rotate(-direction) * (v_Tex - 0.5) + 0.5;
    vec4 color = mix(color1, color2, rotatedUV.x);

    gl_FragColor = mix(color, imageCol, imageCol.a);

}
