precision mediump float;
varying vec2 v_Tex;
uniform sampler2D u_Tex;
uniform sampler2D background;
uniform vec2 effectTextureSize;
uniform vec2 patternTextureSize;

void main(void) {

    vec4 imageCol = texture2D(u_Tex, v_Tex);

    float scale = max(effectTextureSize.x / patternTextureSize.x, effectTextureSize.y / patternTextureSize.y);

    vec2 patternUV = (v_Tex - 0.5) * effectTextureSize / patternTextureSize + 0.5;
    patternUV = (1./scale) * (patternUV - 0.5) + 0.5;
    vec4 patternCol = texture2D(background, patternUV);
    gl_FragColor = mix(patternCol, imageCol, imageCol.a);

}
