uniform mat4 uMVPMatrix;
uniform mat4 uSTMatrix;
uniform highp float uProgress;

attribute vec4 aPosition;
attribute vec4 aTextureCoord;

varying highp vec2 vTextureCoord;
varying highp vec3 tint;
varying highp vec3 mask;

void main() {
    highp vec3 tints[5];
    tints[0] = vec3 (1.0, 0.0, 0.0);
    tints[1] = vec3 (1.0, 1.0, 1.0);
    tints[2] = vec3 (0.9, 0.7, 0.0);
    tints[3] = vec3 (1.0, 0.0, 0.0);
    tints[4] = vec3 (0.45, 0.45, 0.45);

    highp vec3 masks[5];
    masks[0] = vec3 (1.0, 1.0, 1.0);
    masks[1] = vec3 (1.0, 1.0, 1.0);
    masks[2] = vec3 (0.1, 0.1, 1.0);
    masks[3] = vec3 (0.0, 0.0, 0.0);
    masks[4] = vec3 (1.0, 1.0, 1.0);
    float frame = fract (uProgress) * 5.0;

    if (frame < 1.0) {
        tint = tints[0];
        mask = masks[0];
    } else if (frame < 2.0) {
        tint = tints[1];
        mask = masks[1];
    } else if (frame < 3.0) {
        tint = tints[2];
        mask = masks[2];
    } else if (frame < 4.0) {
        tint = tints[3];
        mask = masks[3];
    } else {
        tint = tints[4];
        mask = masks[4];
    }

    highp vec4 position = uMVPMatrix * aPosition;
    gl_Position = vec4 (position.x, position.y, 0.0, 1.0);
    vTextureCoord = (uSTMatrix * aTextureCoord).xy;
}