uniform mat4 uMVPMatrix;
uniform mat4 uSTMatrix;
uniform highp float uProgress;

attribute vec4 aPosition;
attribute vec4 aTextureCoord;

varying highp vec3 vTextureCoord;
varying highp vec3 tint;
varying highp vec3 mask;

void main() {
    highp vec2 slice;
    highp vec3 tints[8];
    highp vec3 masks[8];
    highp vec2 slices[8];

    tints[0] = vec3 (-0.5, -0.6, 0.0);
    tints[1] = vec3 (1.0, 1.0, 1.0);
    tints[2] = vec3 (-0.7, -0.3, -0.8);
    tints[3] = vec3 (-0.7, -0.3, -0.8);
    tints[4] = vec3 (-0.7, -0.3, -0.8);
    tints[5] = vec3 (0.6, 0.25, 0.0);
    tints[6] = vec3 (0.6, 0.25, 0.0);
    tints[7] = vec3 (-0.7, -0.3, -0.8);

    masks[0] = vec3 (2.0, 2.5, 1.0);
    masks[1] = vec3 (0.5, 0.35, 1.0);
    masks[2] = vec3 (3.33, 1.42, 5.0);
    masks[3] = vec3 (3.33, 1.42, 5.0);
    masks[4] = vec3 (3.33, 1.42, 5.0);
    masks[5] = vec3 (0.27, 0.75, 0.12);
    masks[6] = vec3 (0.27, 0.75, 0.12);
    masks[7] = vec3 (3.33, 1.42, 5.0);

    slices[0] = vec2 (0.0, 0.0);
    slices[1] = vec2 (0.0, 0.0);
    slices[2] = vec2 (0.0, 0.0);
    slices[3] = vec2 (0.03, 0.0);
    slices[4] = vec2 (0.08, 0.0);
    slices[5] = vec2 (0.15, 0.73);
    slices[6] = vec2 (0.1, 0.6);
    slices[7] = vec2 (0.0, 0.0);

    float frame = fract (uProgress) * 8.0;

    if (frame < 1.0) {
        tint = tints[0];
        mask = masks[0];
        slice = slices[0];
    } else if (frame < 2.0) {
        tint = tints[1];
        mask = masks[1];
        slice = slices[1];
    } else if (frame < 3.0) {
        tint = tints[2];
        mask = masks[2];
        slice = slices[2];
    } else if (frame < 4.0) {
        tint = tints[3];
        mask = masks[3];
        slice = slices[3];
    } else if (frame < 5.0) {
        tint = tints[4];
        mask = masks[4];
        slice = slices[4];
    } else if (frame < 6.0) {
        tint = tints[5];
        mask = masks[5];
        slice = slices[5];
    } else if (frame < 7.0) {
        tint = tints[6];
        mask = masks[6];
        slice = slices[6];
    } else {
        tint = tints[7];
        mask = masks[7];
        slice = slices[7];
    }

    highp vec4 position = uMVPMatrix * aPosition;
    gl_Position = vec4 (position.x, position.y, 0.0, 1.0);
    vTextureCoord.xy = (uSTMatrix * aTextureCoord).xy;
    vTextureCoord.z = (vTextureCoord.y - slice.x) - vTextureCoord.x * slice.y;
}