#extension GL_OES_EGL_image_external : require
//precision mediump float;
varying highp vec2 vTextureCoord;

uniform samplerExternalOES sTexture;
uniform sampler2D sLut;
uniform highp float uBlend;
uniform mediump vec2 uResolution;
uniform lowp float uProgress;

highp vec4 applyLut(highp vec4 pixel);

mediump vec3 sum(mediump vec2 tex, mediump float height) {
    mediump vec2 uv;
    mediump vec3 d = vec3(0.0);

    for (mediump float y = 0.0; y < 32.0; y += 4.0) {
        if (y >= height) break;
        uv = vec2(abs(tex.x + y/uResolution.x), tex.y);//abs(tex.y + y / uResolution.y)
        d += texture2D(sTexture, uv).rgb;
    }
    d *= 4.0;
    return d / height;
}


void main() {
    mediump vec3 d;
    mediump vec3 c;
    mediump vec3 a = vec3(0.0);

    for (mediump float y = 0.0; y < 8.0; y += 2.0) {
        mediump vec2 uv = vec2(abs(vTextureCoord.x + y/uResolution.x), vTextureCoord.y);//abs(vTextureCoord.y + y/uResolution.y)
        d = texture2D(sTexture, uv).rgb;
        a.g += d.g * 3.0;
    }

    mediump float count = 12.0;
    for (mediump float y = -count; y < count; y += 2.0) {
        mediump vec2 uv = vec2(abs(vTextureCoord.x + y/uResolution.x), vTextureCoord.y);
        c = texture2D(sTexture, uv).rgb;
        d = sum(uv, count);
        a.r += c.r + (d.r - c.r) * (-1.0);
        d = sum(vec2(abs(uv.x + count/uResolution.x), uv.y), count);//abs(uv.y + count/uResolution.y)
        a.b += c.b + (d.b - c.b) * 1.0;
    }

    /*a = vec3 (0.0);

    for (lowp float y = -12.0; y < 12.0; y += 1.0)
    {
    mediump vec2 uv = vec2 (tex.x, abs (tex.y + y / resolution.y));
    c = texture2D (texture, uv).rgb;
    d = sum (vec2 (tex.x, abs (uv.y - 12.0 / resolution.y)), 12.0);
    a += c + (d - c) * 3.5;
    }*/

    a += uProgress*0.00001;
    a /= 12.0;

    gl_FragColor = applyLut(vec4(a.r, a.g, a.b, 1.0));
}

highp vec4 applyLut(highp vec4 pixel) {
    if (uBlend <= 0.0) return pixel;

    if (pixel.x < 0.0) pixel.x = 0.0;
    if (pixel.y < 0.0) pixel.y = 0.0;
    if (pixel.z < 0.0) pixel.z = 0.0;

    if (pixel.x > 1.0) pixel.x = 1.0;
    if (pixel.y > 1.0) pixel.y = 1.0;
    if (pixel.z > 1.0) pixel.z = 1.0;

    highp vec2 look = vec2 (pixel.r * 31.0, pixel.g * 31.0);
    look.x += floor (mod (pixel.b * 31.0, 8.0)) * 32.0;
    look.y += floor (pixel.b * 3.875) * 32.0;
    look.x = (look.x + 0.5) / 256.0;
    look.y = (look.y + 0.5) / 128.0;

    highp vec4 hue = texture2D (sLut, look);
    highp float where = fract (pixel.b * 31.0);

    if (where > 0.003) {
        look.x += 0.125;

        if (look.x > 1.0) {
            look.y += 0.25;
            look.x -= 1.0;
        }

        highp vec4 up = texture2D (sLut, look);
        hue = mix (hue, up, where);
    }

    return mix (pixel, vec4 (hue.r, hue.g, hue.b, 1.0), uBlend);
}