uniform mat4 uMVPMatrix;
uniform mat4 uSTMatrix;
uniform lowp float uProgress;
uniform highp vec2 uResolution;

attribute vec4 aPosition;
attribute vec4 aTextureCoord;

varying highp vec2 vTextureCoord;
varying lowp vec3 vBlock;

void main() {
    highp vec4 position = uMVPMatrix * aPosition;
    gl_Position = vec4 (position.x, position.y, 0.0, 1.0);
    vTextureCoord = (uSTMatrix * aTextureCoord).xy * uResolution;

    highp float up = pow (120000.0, uProgress);
    highp float down = pow (260.0, 1.0 - uProgress);
    vBlock.x = floor (min (up, down) * 2.3);
    vBlock.y = vBlock.x;
    vBlock.z = up / (up + down);
}