uniform mat4 uMVPMatrix;
uniform mat4 uSTMatrix;
uniform highp vec2 uResolution;
uniform highp float uProgress;

attribute vec4 aPosition;
attribute vec4 aTextureCoord;

varying highp vec2 vTextureCoord;
varying highp float vScale;
varying highp float vSpeed;
void main() {
    highp vec4 position = uMVPMatrix * aPosition;
    gl_Position = vec4 (position.x, position.y, 0.0, 1.0);
    vTextureCoord = (uSTMatrix * aTextureCoord).xy;

    highp float up = pow (6000.0, uProgress);
    highp float down = pow (250.0, 1.0 - uProgress);

    if (up < down) {
        vScale = 1.0 - (up - 1.0) * 0.04;
        vSpeed = 0.3 * (1.0 - vScale);
    } else {
        vScale = 1.0 / (1.0 - (down - 1.0) * 0.02);
        vSpeed = 0.3 * (1.0 - vScale);
    }
}